
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 31/OCT/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Wed Oct 31 23:40:49 EST 2007, v0.01 sdy

  This is TypedErrorMessage.h

*/

#ifndef TYPEDERRORMESSAGE_H
#define TYPEDERRORMESSAGE_H


//  C++

#include <iostream> 
#include <iomanip> 
#include <sstream>
#include <ostream> 
#include <string>

//  PACKAGE

#include "ErrorMessage.h"

template <typename T>
class TypedErrorMessage : public ErrorMessage
{

  public:

  TypedErrorMessage()
  {
  };

  TypedErrorMessage(T const code) :
    code_(code)
  {
  }

  TypedErrorMessage(T const code, std::string const & message) :
    ErrorMessage(message),
    code_(code)
  {
  }

  ~TypedErrorMessage()
  {
  };

//clear?

  //  TypedErrorMessage & operator<<(std::string string);
  //  TypedErrorMessage & operator<<(manip_t f);

  friend std::ostream & operator<<(std::ostream & os,
      TypedErrorMessage<T> const & typedErrorMessage)
  {
    os << (ErrorMessage &)typedErrorMessage;
    os << typedErrorMessage.code_;
    return os;
  };

  private:
  
  T code_;

};

#endif





