
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 31/OCT/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Wed Oct 31 23:40:49 EST 2007, v0.01 sdy

  This is TypedException.h

*/

#ifndef TYPEDEXCEPTION_H
#define TYPEDEXCEPTION_H


//  C++

#include <iostream> 
#include <iomanip> 
#include <sstream>
#include <ostream> 
#include <string>

//  PACKAGE

#include "Exception.h"

template <typename T>
class TypedException : public Exception
{

  public:

  TypedException()
  {
  };

  TypedException(T const code) :
    code_(code)
  {
  }

  TypedException(T const code, std::string const & message) :
    Exception(message),
    code_(code)
  {
  }

  ~TypedException() throw()
  {
  };

  friend std::ostream & operator<<(std::ostream & os,
      TypedException<T> const & typedException)
  {
    os << ((Exception &)typedException).what();
    os << typedException.code_; // .what() isn't const
    return os;
  };

  T const
  what()
  {
    return code_;
  };

  private:
  
  T code_;

};

#endif
