
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 06/NOV/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Tue Nov  6 19:05:19 EST 2007, v0.01 sdy

  This is a *very* simple program written to test the Error class.


*/


//  C++

#include <iostream>

//  PACKAGE

#include "TypedException.h"

enum Errors { None, Bad, ReallyBad, YoureScrewed };

int
main(int argc, char *argv[])
{

  int x=0;

  try {
    x=1;
    throw TypedException<int>(3, "123456");
    x=2;
  } catch (TypedException<int> e) {
    std::cout << "Exception what(" << e << ") (ending in 3) with x=" << x << " (1 is correct)" << std::endl;
  }

  try {
    x=1;
    throw new TypedException<int>(4, "123456");
    x=2;
  } catch (TypedException<int> *e) {
    std::cout << "Exception what(" << *e << ") (ending in 4) with x=" << x << " (1 is correct)" << std::endl;
  }

  try {
    x=1;
    throw TypedException<Errors>(ReallyBad, "123456");
    x=2;
  } catch (TypedException<Errors> e) {
    switch (e.what()) {
    case None :
      std::cout << "Exception what(" << e << ") (None) with x=" << x << " (1 is correct)" << std::endl;
      break;
    case Bad :
      std::cout << "Exception what(" << e << ") (Bad) with x=" << x << " (1 is correct)" << std::endl;
      break;
    case ReallyBad :
      std::cout << "Exception what(" << e << ") (ReallyBad) with x=" << x << " (1 is correct)" << std::endl;
      break;
    default :
      std::cout << "Exception what(" << e << ") (x) with x=" << x << " (1 is correct)" << std::endl;
      break;
    }
  }

  try {
    x=1;
    throw new TypedException<Errors>(ReallyBad, "123456");
    x=2;
  } catch (TypedException<Errors> *e) {
    switch (e->what()) {
    case None :
      std::cout << "Exception what(" << *e << ") (None) with x=" << x << " (1 is correct)" << std::endl;
      break;
    case Bad :
      std::cout << "Exception what(" << *e << ") (Bad) with x=" << x << " (1 is correct)" << std::endl;
      break;
    case ReallyBad :
      std::cout << "Exception what(" << *e << ") (ReallyBad) with x=" << x << " (1 is correct)" << std::endl;
      break;
    default :
      std::cout << "Exception what(" << *e << ") (x) with x=" << x << " (1 is correct)" << std::endl;
      break;
    }
  }

}
